package ch.zhaw.projekt2.turnierverwaltung;

import ch.zhaw.projekt2.turnierverwaltung.main.tournamentList.TournamentListController;
import javafx.fxml.FXMLLoader;
import javafx.scene.layout.BorderPane;

import java.io.IOException;
import java.net.URL;

public class Factory {
    private Tournament tournament;
    private FileIO fileIO;

    public Factory(FileIO fileIO){
        this.fileIO = fileIO;
    }

    public Tournament getTournament() {
        return tournament;
    }

    public void setTournament(Tournament tournament) {
        this.tournament = tournament;
    }

    public BorderPane loadMainWindow(){
        FXMLLoader loader = new FXMLLoader(getClass().getResource("mainWindow.fxml"));
        try {
            return loader.load();
        } catch (IOException e) {
            e.printStackTrace();
            //TODO handle and logging
        }
        return null;
    }

    public void loadTournamentList(BorderPane pane){
        TournamentListController controller = (TournamentListController) setCenterOfBorderPane(pane, getClass().getResource("tournamentList/tournamentList.fxml"));
    }

    //Can be used to Open new Scene in same Stage.
    //This way possible to later give object to Controller
    public void loadParticipantFormular(BorderPane pane) {
        setCenterOfBorderPane(pane, getClass().getResource("participantAddFormular/participantFormular.fxml"));
    }

    private FXController setCenterOfBorderPane(BorderPane pane, URL location) {
        FXController controller = null;
        try {
            FXMLLoader loader = new FXMLLoader(location);
            pane.setCenter(loader.load());
            controller = loader.getController();
            controller.setup(tournament, fileIO, this);
            controller.loadContent();
        } catch (IOException e) {
            e.printStackTrace();
            //TODO handle and logging?
        }
        return controller;
    }




}
